<?php
if(function_exists('file_get_contents')){
	$data=file_get_contents("php://input");
}else{
	$data=$GLOBALS["HTTP_RAW_POST_DATA"];
}
use Qiniu\Auth;
use Qiniu\Storage\BucketManager;
use Qiniu\Processing\PersistentFop;

if($data){
	if($_S['qiniu']){
		require_once './sdk/Qiniu/autoload.php';
	  
		$accessKey = $_S['setting']['qiniu_ak'];
		$secretKey = $_S['setting']['qiniu_sk'];
		$bucket = $_S['setting']['qiniu_bucket'];
		$auth = new Auth($accessKey, $secretKey);
		$bucketMgr = new BucketManager($auth);
		$_GET['type']=$_GET['type']?$_GET['type']:'smsot';
		
		$token=getapival('access_token');
		$url='https://api.weixin.qq.com/cgi-bin/media/get?access_token='.$token.'&media_id='.$data;
		
		$res=$bucketMgr->fetch($url, $bucket);
		if($res[0]['key']){
			$pipeline=$_S['setting']['qiniu_pipeline'];
			$pfop = new PersistentFop($auth);
			
			$Mp3Fop = "avthumb/mp3/ab/320k/ar/44100/acodec/libmp3lame|saveas/".\Qiniu\base64_urlSafeEncode($bucket.":".$res[0]['key'].".mp3");
			$pfop->execute($bucket,$res[0]['key'],$Mp3Fop,$_S['setting']['qiniu_pipeline']);
			
			$v['uid']=$_S['uid'];
			$v['src']=$_S['setting']['qiniu_domain'].$res[0]['key'];
			$v['size']=$res[0]['fsize'];
			$v['type']=$res[0]['mimeType'];
			$v['time']=ceil($_GET['time']/1000);
			$v['dateline']=$_S['timestamp'];
			
			$aid=insert('common_voice',$v);
			if($_GET['type']=='dz'){
				
			}else{
				$code='<img class="audiostyle" data="'.$aid.'" src="ui/voice.png"/>';
				showmessage('','',array('type'=>'toast','fun'=>'smsot.editor(\''.$code.'\')'));		
			}
		}
	}else{
		showmessage('没有配置七牛服务器');
	}
}else{
	showmessage('上传到微信失败');
}


?>